/* C++ class header grammatic
 * (C)2005 Denis "jaromil" Rojo
 * licensed under the GNU GPL   */

%x newclass
%x inherit
%x classdec
%x classins
%x public
%x args

name	([\~A-Za-z0-9\-\*_]+)
sp	([ \t\n]+)

%{
#include <semantics.h>
%}

%%

"class"				BEGIN(newclass);

<newclass>{name}		open_class(yytext); BEGIN(classdec);

<classdec>":"{sp}"public"	BEGIN(inherit);

<inherit>{name}    		add_inheritance(yytext); BEGIN(classdec);

<classdec>"{"			BEGIN(classins);

<classdec>";"			close_class(); BEGIN(INITIAL);

<classins>"public:"		BEGIN(public);

<classins>"};"			close_class(); BEGIN(INITIAL);

<public>{name}{sp}({name}{sp})*{name}{sp}*"("	{
				yytext[yyleng-1] = '\0';
				open_method(yytext);
				} BEGIN(args);

<args>{name}{sp}{name}({sp}{name})*	add_argument(yytext);

<args>";" 			close_method(); BEGIN(public);

<public>{name}{sp}({name}{sp})*\*?{name}{sp}*";"	{
				yytext[yyleng-1] = '\0';
				add_property(yytext);
				}

<public>("private:"|"protected:")	BEGIN(classins);

<public>"};"			close_class(); BEGIN(INITIAL);


<*>"/*"     {
            register int c;
            for ( ; ; ) {
              while ( (c = yyinput()) != '*' && c != EOF );
              /* eat up text of comment */
              if ( c == '*' ) {
                while ( (c = yyinput()) == '*' );
                if ( c == '/' ) break;    /* found the end */
              }
              if ( c == EOF ) {
                fprintf(stderr, "EOF in comment\n");
                break;
              }
            }
            }
<*>"//".*\n	/* it's a comment */

<*>{sp}+	/* eat up whitespaces */

<*>.|\n		/* nop */

 
